package ffp_examples;

/*
 *  cube.java
 *  This program demonstrates a single modeling transformation,
 *  ffp.ffpScalef() and a single viewing transformation.
 *  A wireframe cube is rendered.
 */
public class cube extends DemoBase {

	public static void main(String[] args) {
		new cube().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection();
	}

	private static void create_projection() {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		ffp.ffpFrustum(-1.0f, 1.0f, -1.0f, 1.0f, 1.5f, 20.0f);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpShadeModel(FFP_FLAT);
	}

	@Override
	public void dbUpdate() {

	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);
		ffp.ffpColor3f(1.0f, 1.0f, 1.0f);
		ffp.ffpLoadIdentity(); /* clear the matrix */
		/* viewing transformation  */
		ffp.ffpTranslatef(0.0f, 0.0f, -5.0f);
		ffp.ffpScalef(1.0f, 2.0f, 1.0f); /* modeling transformation */
		aux.auxWireCube(1.0f);
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
