package ffp_examples;

/*
 *  model.java
 *  This program demonstrates modeling transformations.
 */

public class model extends DemoBase {

	public static void main(String[] args) {
		new model().init(EUT_RGB);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		if (w <= h) {
			ffp.ffpOrtho(-50.0f, 50.0f, -50.0f * h / w, 50.0f * h / w, -1.0f, 1.0f);
		} else {
			ffp.ffpOrtho(-50.0f * w / h, 50.0f * w / h, -50.0f, 50.0f, -1.0f, 1.0f);
		}
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		create_projection(width, height);
		ffp.ffpShadeModel(FFP_FLAT);
	}

	@Override
	public void dbUpdate() {

	}

	private static void draw_triangle() {
		ffp.ffpBegin(FFP_LINE_LOOP);
		ffp.ffpVertex2f(0.0f, 25.0f);
		ffp.ffpVertex2f(25.0f, -25.0f);
		ffp.ffpVertex2f(-25.0f, -25.0f);
		ffp.ffpEnd();
	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);
		ffp.ffpColor1f(1.0f);

		ffp.ffpLoadIdentity();
		draw_triangle();

		ffp.ffpEnable(FFP_LINE_STIPPLE);
		ffp.ffpLineStipple(1, (short) 0xf0f0);
		ffp.ffpLoadIdentity();
		ffp.ffpTranslatef(-20.0f, 0.0f, 0.0f);
		draw_triangle();

		ffp.ffpLineStipple(1, (short) 0xf00f);
		ffp.ffpLoadIdentity();
		ffp.ffpScalef(1.5f, 0.5f, 1.0f);
		draw_triangle();

		ffp.ffpLineStipple(1, (short) 0x8888);
		ffp.ffpLoadIdentity();
		ffp.ffpRotatef(90.0f, 0.0f, 0.0f, 1.0f);
		draw_triangle();
		ffp.ffpDisable(FFP_LINE_STIPPLE);

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
