package ffp_examples;

/*
 *  movelights.java
 */
public class movelights extends DemoBase {

	public static void main(String[] args) {
		new movelights().init(EUT_RGB);
	}

	static float position[] = { 0.0f, 0.0f, 1.0f, 1.0f };
	static float position2[] = { 0.0f, 0.0f, 1.0f, 1.0f };
	static float position3[] = { 1.0f, 0.0f, 0.0f, 1.0f };

	static int spin = 0;
	static int spin2 = 0;
	static int spin3 = 0;
	static float irad = 0.275f, orad = 0.85f;
	static int lod = 7;

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		aux.auxPerspective(40.0f, (float) w / (float) h, 1.0f, 20.0f);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
		ffp.ffpLoadIdentity();
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpShadeModel(FFP_SMOOTH);
		ffp.ffpEnable(FFP_LIGHTING);
		ffp.ffpEnableLight(0);
		ffp.ffpEnableLight(1);
		ffp.ffpEnableLight(2);
		ffp.ffpEnable(FFP_DEPTH_TEST);
		ffp.ffpEnable(FFP_NORMALIZE);

		float ambient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
		float specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		int lmodel_ambient[] = { 34, 34, 34 };

		for (int i = 0; i < 3; i++) {
			position[i] *= 1.5f;
			position2[i] *= 1.5f;
			position3[i] *= 1.5f;
		}

		float diffuseA[] = { 0, 1, 1 };
		float diffuseB[] = { 1, 1, 0 };
		float diffuseC[] = { 1, 0, 1 };

		ffp.ffpLightfv(0, FFP_AMBIENT, ambient);
		ffp.ffpLightfv(0, FFP_DIFFUSE, diffuseA);
		ffp.ffpLightfv(0, FFP_SPECULAR, specular);
		ffp.ffpLightfv(0, FFP_POSITION, position);

		ffp.ffpLightfv(1, FFP_AMBIENT, ambient);
		ffp.ffpLightfv(1, FFP_DIFFUSE, diffuseB);
		ffp.ffpLightfv(1, FFP_SPECULAR, specular);
		ffp.ffpLightfv(1, FFP_POSITION, position2);

		ffp.ffpLightfv(2, FFP_AMBIENT, ambient);
		ffp.ffpLightfv(2, FFP_DIFFUSE, diffuseC);
		ffp.ffpLightfv(2, FFP_SPECULAR, specular);
		ffp.ffpLightfv(2, FFP_POSITION, position3);
		ffp.ffpLightModeliv(FFP_LIGHT_MODEL_AMBIENT, lmodel_ambient);
		ffp.ffpLightModeli(FFP_LIGHT_MODEL_LOCAL_VIEWER, FFP_TRUE);

		ffp.ffpMaterialfv(FFP_SPECULAR, specular);
		ffp.ffpMaterialf(FFP_SHININESS, 96.0f);
	}

	@Override
	public void dbUpdate() {
		if (keyPressed(KEY_S)) {
			if (ffp.ffpGetInteger(FFP_SMOOTH_MODEL) == FFP_PHONG) {
				ffp.ffpSmoothModel(FFP_GOURAUD);
			} else {
				ffp.ffpSmoothModel(FFP_PHONG);
			}
		}
		if (mouseLeftButtonActive()) {
			spin2 = (spin2 - 1) % 360;
		}
		if (mouseMiddleButtonActive()) {
			spin = (spin + 1) % 360;
		}
		if (mouseRightButtonActive()) {
			spin3 = (spin3 + 1) % 360;
		}
		if (keyPressed(KEY_R)) {
			irad += 0.1f;
		}
		if (keyPressed(KEY_F)) {
			irad -= 0.1f;
		}
		if (keyPressed(KEY_T)) {
			orad += 0.1f;
		}
		if (keyPressed(KEY_G)) {
			orad -= 0.1f;
		}
	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);
		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0, 0, -5);

		{
			ffp.ffpPushMatrix();
			ffp.ffpRotatef(spin, 1, 0, 0);
			ffp.ffpLightfv(0, FFP_POSITION, position);
			ffp.ffpTranslatef(position[0], position[1], position[2]);

			ffp.ffpDisable(FFP_LIGHTING);
			ffp.ffpColor3ub(0, 255, 255);
			aux.auxWireCube(0.1f);
			ffp.ffpEnable(FFP_LIGHTING);
			ffp.ffpPopMatrix();
		}

		{
			ffp.ffpPushMatrix();
			ffp.ffpRotatef(spin2, 0, 1, 0);
			ffp.ffpLightfv(1, FFP_POSITION, position2);
			ffp.ffpTranslatef(position2[0], position2[1], position2[2]);

			ffp.ffpDisable(FFP_LIGHTING);
			ffp.ffpColor3ub(255, 255, 0);
			aux.auxWireCube(0.1f);
			ffp.ffpEnable(FFP_LIGHTING);
			ffp.ffpPopMatrix();
		}

		{
			ffp.ffpPushMatrix();
			ffp.ffpRotatef(spin3, 0, 0, 1);
			ffp.ffpLightfv(2, FFP_POSITION, position3);
			ffp.ffpTranslatef(position3[0], position3[1], position3[2]);

			ffp.ffpDisable(FFP_LIGHTING);
			ffp.ffpColor3ub(255, 0, 255);
			aux.auxWireCube(0.1f);
			ffp.ffpEnable(FFP_LIGHTING);
			ffp.ffpPopMatrix();
		}
		aux.auxSolidTorus(irad, orad, 16, 16);
		ffp.ffpPopMatrix();
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
