package ffp_examples;

public class parametric extends DemoBase {

	static float rotate_x = 30;
	static float rotate_y = 15;
	static float translate_z = 8;

	static float ctx = 0;
	static float cty = 0;

	static float time;
	static int xold, yold;
	float granularity = 0.1f;

	static void f(float t, float[] d) {
		d[0] = 3 * cos(3 * t) / 2;
		d[1] = 3 * sin(3 * t) / 2;
		d[2] = 2.0f * t / 5.0f;
	}

	static void sphere(float u, float v, float[] d) {
		d[0] = sin(u) * cos(v);
		d[1] = sin(u) * sin(v);
		d[2] = cos(u);
	}

	static void mobius(float u, float v, float[] d) {
		d[0] = (1 + 0.5f * v * cos(0.5f * u)) * cos(u);
		d[1] = (1 + 0.5f * v * cos(0.5f * u)) * sin(u);
		d[2] = 0.5f * v * sin(0.5f * u);
	}

	static void torus(float u, float v, float[] d) {
		d[0] = (3 + cos(v)) * cos(u);
		d[1] = (3 + cos(v)) * sin(u);
		d[2] = sin(v);
	}

	public static void main(String[] args) {
		new parametric().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		aux.auxPerspective(45, w / (float) h, 0.1f, 150f);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpLineWidth(8);
		ffp.ffpEnable(FFP_DEPTH_TEST);
		ffp.ffpShadeModel(FFP_SMOOTH);
	}

	@Override
	public void dbUpdate() {
		time += 0.01f;
		int x = mouseX();
		int y = mouseY();
		if (mouseLeftButtonActive()) {
			rotate_y = rotate_y + (y - yold) / 5.0f;
			rotate_x = rotate_x + (x - xold) / 5.0f;
			if (rotate_y > 90) {
				rotate_y = 90;
			}
			if (rotate_y < -90) {
				rotate_y = -90;
			}
		}
		if (mouseRightButtonActive()) {
			rotate_x = rotate_x + (x - xold) / 5.0f;
			translate_z = translate_z + (yold - y) / 50.0f;
			if (translate_z < 0.5f) {
				translate_z = 0.5f;
			}
			if (translate_z > 100) {
				translate_z = 100;
			}
		}
		if (keyPressed('r')) {
			granularity += 0.05f;
			if (granularity > 1) {
				granularity = 1;
			}
		}
		if (keyPressed('f')) {
			granularity -= 0.05f;
			if (granularity < 0.01f) {
				granularity = 0.01f;
			}
		}
		xold = x;
		yold = y;
	}

	static boolean curve = true;
	static float[] d = new float[3];

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);
		ffp.ffpDisable(FFP_LIGHTING);
		ffp.ffpLoadIdentity();
		ffp.ffpTranslatef(0, 0, -translate_z);
		ffp.ffpRotatef(rotate_y, 1, 0, 0);
		ffp.ffpRotatef(rotate_x, 0, 1, 0);
		ffp.ffpBegin(FFP_LINE_STRIP);
		for (float t = -5; t < 5; t += granularity) {
			f(t, d);
			ffp.ffpColor3fv(d);
			ffp.ffpVertex3fv(d);
		}
		/*for (float u = 0; u < PI; u += granularity) {
			for (float v = 0; v < PI * 2; v += granularity) {
				sphere(u, v, d);
				ffp.ffpColor3fv(d);
				ffp.ffpVertex3fv(d);
			}
		}*/
		/*for (float u = 0; u < PI * 2; u += granularity) {
			for (float v = -1; v < 1; v += granularity) {
				mobius(u, v, d);
				ffp.ffpColor3fv(d);
				ffp.ffpVertex3fv(d);
			}
		}*/
		/*	for (float u = 0; u < PI * 2; u += granularity) {
				for (float v = 0; v < PI * 2; v += granularity) {
					torus(u, v, d);
					ffp.ffpColor3fv(d);
					ffp.ffpVertex3fv(d);
				}
			}*/
		ffp.ffpEnd();
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
