package ffp_examples;

public class polar extends DemoBase {

	static float f(float theta) {
		return 0.75f * cos(0.25f * theta);
	}

	static float[] cartesian(float r, float theta, float[] d) {
		d[0] = r * cos(theta);
		d[1] = r * sin(theta);
		return d;
	}

	public static void main(String[] args) {
		new polar().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		if (w <= h) {
			aux.auxOrtho2D(-1.0f, 1.0f, -1.0f, 1.0f * h / w);
		} else {
			aux.auxOrtho2D(-1.0f, 1.0f * w / h, -1.0f, 1.0f);
		}
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpEnable(FFP_DEPTH_TEST);
		ffp.ffpShadeModel(FFP_SMOOTH);
	}

	@Override
	public void dbUpdate() {

	}

	static float[] d = new float[2];

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);
		ffp.ffpLoadIdentity();
		ffp.ffpBegin(FFP_LINE_STRIP);
		int subdivisions = 256;
		float end = PI * 16;
		float step = end / subdivisions;
		for (float theta = 0; theta < end; theta += step) {
			ffp.ffpVertex2fv(cartesian(f(theta), theta, d));
		}
		ffp.ffpEnd();
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
