package ffp_examples;

/*
 *  torusclip.java
 */
public class torusclip extends DemoBase {

	public static void main(String[] args) {
		new torusclip().init(EUT_RGB);
	}

	static float light_ambient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	static float light_diffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	static float light_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	/* light_position is NOT default value */
	static float light_position[] = { 1.0f, 1.0f, 1.0f, 0.0f };

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		if (w <= h) {
			ffp.ffpOrtho(-4.0f, 4.0f, -4.0f * h / w, 4.0f * h / w, -10.0f, 10.0f);
		} else {
			ffp.ffpOrtho(-4.0f * w / h, 4.0f * w / h, -4.0f, 4.0f, -10.0f, 10.0f);
		}
		ffp.ffpMatrixMode(FFP_MODELVIEW);
		ffp.ffpLoadIdentity();
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpShadeModel(FFP_SMOOTH);
		ffp.ffpEnable(FFP_DEPTH_TEST);
		ffp.ffpEnable(FFP_LIGHTING);
		ffp.ffpEnable(FFP_NORMALIZE);
		ffp.ffpEnableLight(0);

		ffp.ffpLightfv(0, FFP_AMBIENT, light_ambient);
		ffp.ffpLightfv(0, FFP_DIFFUSE, light_diffuse);
		ffp.ffpLightfv(0, FFP_SPECULAR, light_specular);
		ffp.ffpLightfv(0, FFP_POSITION, light_position);
	}

	@Override
	public void dbUpdate() {

	}

	float eqn[] = { 0.0f, 0.0f, -1.0f, 0.2f };
	float mat_diffuse[] = { 0.8f, 0.8f, 0.8f, 1.0f };
	float back_diffuse[] = { 0.8f, 0.2f, 0.8f, 1.0f };

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);

		ffp.ffpPushMatrix();
		ffp.ffpClipPlane(FFP_CLIP_PLANE0, eqn); /* slice objects */
		ffp.ffpEnable(FFP_CLIP_PLANE0);

		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0.0f, 2.0f, 0.0f);
		aux.auxSolidTorus(0.275f, 0.7f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpLightModeli(FFP_LIGHT_MODEL_TWO_SIDE, FFP_TRUE);
		ffp.ffpMaterialfv(FFP_DIFFUSE, mat_diffuse);
		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0.0f, 0.0f, 0.0f);
		aux.auxSolidTorus(0.275f, 0.7f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpMaterialfv(FFP_DIFFUSE, back_diffuse);
		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0.0f, -2.0f, 0.0f);
		aux.auxSolidTorus(0.275f, 0.7f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpLightModeli(FFP_LIGHT_MODEL_TWO_SIDE, FFP_FALSE);
		ffp.ffpDisable(FFP_CLIP_PLANE0);
		ffp.ffpPopMatrix();

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
